﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using Keyoti.RapidSpell;
using System.Web.Hosting;
using System.IO;
using System.Collections.Generic;

namespace RSSL_ServerUserDictionary.Web
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class UserDictionaryService
    {
        string DictionaryFile
        {
            get
            {
                string file = Path.Combine(HostingEnvironment.ApplicationPhysicalPath, "userDict.txt");
                if (!File.Exists(file))
                    File.Create(file).Close();
                return file;
            }
        }
        [OperationContract]
        public List<string> ReadAll()
        {

            using (StreamReader reader = new StreamReader(DictionaryFile))
            {
                List<string> list = new List<string>();
                string line;
                while ((line = reader.ReadLine()) != null)
                {
                    list.Add(line);
                }
                return list;
            }

        }

        [OperationContract]
        public void SaveList(List<string> list)
        {

            using (StreamWriter writer = new StreamWriter(DictionaryFile, false))
            {
                foreach(string word in list)
                    writer.WriteLine(word);
            }

        }


        [OperationContract]
        public void AddWord(string word)
        {

            using (StreamWriter writer = new StreamWriter(DictionaryFile, true))
            {
                writer.WriteLine(word);
            }

        }

        [OperationContract]
        public void RemoveWord(string word)
        {

            List<string> words = ReadAll();
            words.Remove(word);
            SaveList(words);

        }


    }
}
