﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace RSSL_ServerUserDictionary
{
    class CUserDictionary : Keyoti.RapidSpell.UserDictionary
    {
        UDServiceReference.UserDictionaryServiceClient service;
        bool loading = false, isValid = true;

        Keyoti.RapidSpell.ArrayList copy;

        public CUserDictionary()
        {
            loading = true;
            service = new UDServiceReference.UserDictionaryServiceClient();

            service.ReadAllCompleted += new EventHandler<UDServiceReference.ReadAllCompletedEventArgs>(service_ReadAllCompleted);
            service.ReadAllAsync();
        }

        void service_ReadAllCompleted(object sender, UDServiceReference.ReadAllCompletedEventArgs e)
        {
            copy = new Keyoti.RapidSpell.ArrayList();
            foreach (string s in e.Result)
                copy.Add(s);

            loading = false;
        }



        public override int ReadAll(Keyoti.RapidSpell.ArrayList list)
        {
            int c = 0;
            while (loading && ++c < 200)//wait for constructor to finish loading, in case this is called too soon - or give up if timedout
                System.Threading.Thread.Sleep(100);

            if (c == 200)
            {
                isValid = false;
                return 0;
            }
            else
            {
                list.AddRange(copy);
                return copy.Count;
            }
        }

        public override bool AddWord(string word)
        {
            copy.Add(word);
            service.AddWordAsync(word);//dont need to wait for it to finish
            return true;
        }




        public override bool RemoveWord(string word)
        {
            copy.Remove(word);
            service.RemoveWordAsync(word);//dont need to wait for it to finish
            return true;
        }

        public override bool IsValid()
        {
            return isValid;
        }

        public override void SaveList(Keyoti.RapidSpell.ArrayList newList)
        {
            System.Collections.ObjectModel.ObservableCollection<string> sendList = new System.Collections.ObjectModel.ObservableCollection<string>();
            foreach (string w in newList)
                sendList.Add(w);
            service.SaveListAsync(sendList);
        }


    }
}
